//
//  ContentView.swift
//  MainActorBox
//
//  Created by Timothy Moose on 2/23/24.
//

import SwiftUI
import SwiftMessages
import Resolver

struct ContentView: View {

    enum Message: Identifiable {
        case test

        var id: String {
            "test"
        }
    }

    @State var message: Message?

    var body: some View {
        let swiftMessagesBox: MainActorBox<SwiftMessages> = Resolver.resolve()
        Button("Tap") {
            message = .test
        }
        .swiftMessage(message: $message, swiftMessages: swiftMessagesBox.instance) { message in
            Text("Test \(message.id)")
                .frame(maxWidth: .infinity)
                .padding()
                .background(.yellow)
        }
    }
}

#Preview {
    ContentView()
}
