//
//  MainActorBox.swift
//  MainActorBox
//
//  Created by Timothy Moose on 2/23/24.
//

import Foundation

class MainActorBox<T> {
    init(instance: @escaping @MainActor () -> T) {
        self.factory = instance
    }

    @MainActor
    var instance: T {
        let instance = _instance ?? factory()
        _instance = instance
        return instance
    }

    private let factory: @MainActor () -> T
    @MainActor private var _instance: T?
}
